# -*- coding: utf-8 -*-
# +--------------------------------------------------------------------
#  ██╗██╗    ██╗██████╗  ██████╗
#  ██║██║    ██║╚════██╗██╔════╝
#  ██║██║ █╗ ██║ █████╔╝██║
#  ██║██║███╗██║ ╚═══██╗██║
#  ██║╚███╔███╔╝██████╔╝╚██████╗
#  ╚═╝ ╚══╝╚══╝ ╚═════╝  ╚═════╝
# DDNS 自动配置脚本
# Author : Sudem (mail@szhcloud.cn)
# Date: 2019-11-24
# Version : 1.0
# CopyRight : iw3c.top
# +--------------------------------------------------------------------


import requests,json,os,time
# 干掉讨厌的 https 警告
import urllib3
urllib3.disable_warnings()


# 读取文件
def ReadFile(filename,mode = 'r'):
    if not os.path.exists(filename): return False
    try:
        fp = open(filename, mode)
        f_body = fp.read()
        fp.close()
    except Exception as ex:
        if sys.version_info[0] != 2:
            try:
                fp = open(filename, mode,encoding="utf-8");
                f_body = fp.read()
                fp.close()
            except Exception as ex2:
                return False
        else:
            return False
    return f_body

# 写入文件
def WriteFile(filename,s_body,mode='w+'):
    try:
        fp = open(filename, mode);
        fp.write(s_body)
        fp.close()
        return True
    except:
        try:
            fp = open(filename, mode,encoding="utf-8")
            fp.write(s_body)
            fp.close()
            return True
        except:
            return False


# 获取当前的ip 地址信息
def GetIpLoacal(ip):
    local=requests.get("https://v2.api.iw3c.top/?api=ip&ip="+ip).text
    local = json.loads(local)
    if local["Hlocal"]!="":
        local["local"] = local["Hlocal"]
    return local

# 获取当前的ip 地址
def GetIpconfig():
    ip = requests.get("http://ip.iw3c.top").text
    ip = ip.replace("\n","")
    return ip

# 读取缓存的ip 地址
def ReadIpCache():
    if not os.path.exists("ip.json"):
        return ""
    F=ReadFile("ip.json")
    ip = json.loads(F)["ip"]
    return ip

# 写入缓存的ip地址
def WriteIpCache(ip):
    J = {"ip":ip,"time":time.strftime("%Y-%m-%d %H:%M:%S", time.localtime()) }
    WriteFile("ip.json",json.dumps(J))


from aliyunsdkalidns.request.v20150109 import UpdateDomainRecordRequest, AddDomainRecordRequest,DescribeDomainRecordsRequest
from aliyunsdkcore import client




def Check_Record(ip):
    clt = client.AcsClient(access_key_id, access_key_secret, 'cn-hangzhou')
    request = DescribeDomainRecordsRequest.DescribeDomainRecordsRequest()
    request.set_DomainName(ddns_domain)
    request.set_RRKeyWord(ddns_host)
    request.set_accept_format("json")
    result = json.loads(clt.do_action_with_exception(request))
    Records = result["DomainRecords"]["Record"]
    i = len(Records)
    if i == 0:
        return  False
    else:
        RecordId = Records[0]["RecordId"]
        if ip != Records[0]["Value"]:
            return RecordId
        else:
            return "EXIST"

def Insert_Record(ip):
    clt = client.AcsClient(access_key_id, access_key_secret, 'cn-hangzhou')
    request  = AddDomainRecordRequest.AddDomainRecordRequest()
    request.set_DomainName(ddns_domain)
    request.set_RR(ddns_host)
    request.set_Type("A")
    request.set_Value(ip)
    request.set_accept_format("json")
    result = json.loads(clt.do_action_with_exception(request))
    if result["RecordId"]:
        print ("[" + time.strftime("%Y-%m-%d %H:%M:%S", time.localtime()) + "] 添加 DNS记录成功")

def Update_Record(ip,RecordId):
    clt = client.AcsClient(access_key_id, access_key_secret, 'cn-hangzhou')
    request = UpdateDomainRecordRequest.UpdateDomainRecordRequest()
    #request.set_DomainName(ddns_domain)
    request.set_RR(ddns_host)
    request.set_Type("A")
    request.set_Value(ip)
    request.set_accept_format("json")
    request.set_RecordId(RecordId)
    result = json.loads(clt.do_action_with_exception(request))
    if result["RecordId"]:
        print ("[" + time.strftime("%Y-%m-%d %H:%M:%S", time.localtime()) + "] 更新 DNS记录成功")


access_key_id = ""
access_key_secret = ""
ddns_domain = ""
ddns_host = ""



if __name__ == '__main__':
    # 启动时删除ip.json 用来强制刷新IP地址
    if os.path.exists("ip.json"):
        os.remove("ip.json")
    # 读取配置文件
    config = json.loads(ReadFile("config.json"))
    access_key_id = config["ACCESS_ID"]
    access_key_secret = config["ACCESS_KEY"]
    ddns_domain= config["DDNS_DOMAIN"]
    ddns_host = config["DDNS_HOST"]
    while True:
        try:
            _ip = ReadIpCache()
            ip = GetIpconfig()
            if ip != _ip and ip != "":
                WriteIpCache(ip)
                local = GetIpLoacal(ip)
                print ("[" + time.strftime("%Y-%m-%d %H:%M:%S", time.localtime()) + "] 检测到外网IP地址发生变化")
                print ("[新的外网IP地址]:" + ip.encode(encoding='UTF-8', errors='strict'))
                print ("[IP地址位置信息]:" + local["data"]["local"].encode(encoding='UTF-8', errors='strict'))
                print ("[运营商]:" + local["data"]["isp"].encode(encoding='UTF-8', errors='strict'))
                print ("[ASN 网段信息]:")
                i = len(local["data"]["asn"]) - 1
                m = 1
                while m <= i:
                    print ("        [CODE]:" + local["data"]["asn"][str(m)]["code"].encode(encoding='UTF-8',
                                                                                           errors='strict') + "      [CIDR]:" +
                           local["data"]["asn"][str(m)]["cidr"].encode(encoding='UTF-8',
                                                                       errors='strict') + "      [INFO]:" +
                           local["data"]["asn"][str(m)]["info"].encode(encoding='UTF-8', errors='strict'))
                    m = m + 1
                    RecordId = Check_Record(ip)
                if not RecordId:
                    Insert_Record(ip)
                else:
                    if RecordId != "EXIST":
                        Update_Record(ip, RecordId)
                    else:
                        print ("[" + time.strftime("%Y-%m-%d %H:%M:%S", time.localtime()) + "] DNS 记录无需变更!")
        except:
            pass
        time.sleep(10)




